/*
 * Written by Solar Designer and placed in the public domain.
 * See crypt_blowfish.c for more information.
 */

#ifdef __i386__

#ifdef __OpenBSD__
#define UNDERSCORES
#define ALIGN_LOG
#endif

#ifdef UNDERSCORES
#define _BF_body_r			__BF_body_r
#endif

#ifdef ALIGN_LOG
#define DO_ALIGN(log)			.align (log)
#elif defined(DUMBAS)
#define DO_ALIGN(log)			.align 1 << log
#else
#define DO_ALIGN(log)			.align (1 << (log))
#endif

#define BF_FRAME			0x200
#define ctx				%esp

#undef L
#undef R
#undef tmp1
#undef tmp2
#define L				%esi
#define R				%edi
#define tmp1				%ecx
#define tmp1_lo				%cl
#define tmp2				%ebp

#define S(N, r)				N+BF_FRAME(ctx,r,4)
#ifdef DUMBAS
#define P(N)				0x1000+N+N+N+N+BF_FRAME(ctx)
#else
#define P(N)				0x1000+4*N+BF_FRAME(ctx)
#endif

.data
DO_ALIGN(3)
save_esp:
.long 0
BF_ptr:
.long 0

.text

#define BF_ROUND(L, R, N) \
	xorl L,%eax; \
	xorl tmp1,tmp1; \
	movl %eax,L; \
	shrl $16,%eax; \
	movl L,%edx; \
	movb %ah,tmp1_lo; \
	andl $0xFF,%eax; \
	movb %dh,%bl; \
	andl $0xFF,%edx; \
	movl S(0,tmp1),tmp1; \
	movl S(0x400,%eax),tmp2; \
	addl tmp2,tmp1; \
	movl S(0x800,%ebx),tmp2; \
	xorl tmp2,tmp1; \
	movl S(0xC00,%edx),tmp2; \
	addl tmp1,tmp2; \
	movl 4+P(N),%eax; \
	xorl tmp2,R

#define BF_ENCRYPT_START \
	BF_ROUND(L, R, 0); \
	BF_ROUND(R, L, 1); \
	BF_ROUND(L, R, 2); \
	BF_ROUND(R, L, 3); \
	BF_ROUND(L, R, 4); \
	BF_ROUND(R, L, 5); \
	BF_ROUND(L, R, 6); \
	BF_ROUND(R, L, 7); \
	BF_ROUND(L, R, 8); \
	BF_ROUND(R, L, 9); \
	BF_ROUND(L, R, 10); \
	BF_ROUND(R, L, 11); \
	BF_ROUND(L, R, 12); \
	BF_ROUND(R, L, 13); \
	BF_ROUND(L, R, 14); \
	BF_ROUND(R, L, 15); \
	movl BF_ptr,tmp2; \
	xorl L,%eax; \
	movl P(17),L

#define BF_ENCRYPT_END \
	xorl R,L; \
	movl %eax,R

DO_ALIGN(5)
.globl _BF_body_r
_BF_body_r:
	movl 4(%esp),%eax
	pushl %ebp
	pushl %ebx
	pushl %esi
	pushl %edi
	subl $BF_FRAME,%eax
	movl %esp,save_esp
	cmpl %esp,%eax
	ja BF_die
	movl %eax,%esp
	xorl L,L
	addl $0x1000+BF_FRAME,%eax
	xorl R,R
	movl %eax,BF_ptr
	movl P(0),%eax
	xorl %ebx,%ebx
BF_loop_P:
	BF_ENCRYPT_START
	addl $8,tmp2
	BF_ENCRYPT_END
	leal 0x1000+18*4+BF_FRAME(ctx),%eax
	movl tmp2,BF_ptr
	cmpl tmp2,%eax
	movl L,-8(tmp2)
	movl R,-4(tmp2)
	movl P(0),%eax
	ja BF_loop_P
	leal BF_FRAME(ctx),tmp2
	xorl %ebx,%ebx
	movl tmp2,BF_ptr
BF_loop_S:
	BF_ENCRYPT_START
	BF_ENCRYPT_END
	movl P(0),%eax
	movl L,(tmp2)
	movl R,4(tmp2)
	BF_ENCRYPT_START
	BF_ENCRYPT_END
	movl P(0),%eax
	movl L,8(tmp2)
	movl R,12(tmp2)
	BF_ENCRYPT_START
	BF_ENCRYPT_END
	movl P(0),%eax
	movl L,16(tmp2)
	movl R,20(tmp2)
	BF_ENCRYPT_START
	addl $32,tmp2
	BF_ENCRYPT_END
	leal 0x1000+BF_FRAME(ctx),%eax
	movl tmp2,BF_ptr
	cmpl tmp2,%eax
	movl P(0),%eax
	movl L,-8(tmp2)
	movl R,-4(tmp2)
	ja BF_loop_S
	movl save_esp,%esp
	popl %edi
	popl %esi
	popl %ebx
	popl %ebp
	ret

BF_die:
	hlt
	jmp BF_die

#endif
